#include    <stdio.h>
#include    <math.h>

/*   This program inputs ".4HC" files from PCFILT that contain data for
** transmission line designs 
*/

struct temx {
    double  cs,     /* self */
            cm,     /* mutual */
           zoe,     /* Even mode Zo  */
           zoo,     /* Odd mode Zo.  */
            zo,     /* Resonator Zo. */
             G,     /* Normalized lowpass value */
             K,     /* Ki,i+1 */
           Kbw;     /* Coupling bandwidth */
    } tm[22];

main(argc,argv) 
int argc;
char *argv[];
{
char name[40],buf[90];
int i,n;
FILE *file;
double atof();

  if (argc == 1) {
      printf("Input what file (Cr = default) "); gets(name); 
      if (*name == '\0') strcpy (name ,"DEFAULT"); 
  }
  else {
      strcpy (name , argv[1]); printf("File: %s\n", argv[1]);
  }
  strcpy (buf, name); strcat(buf,".4hc"); 

  file = fopen(buf,"r");
  if (file == NULL) { printf("%s not found\n", buf); exit(1); }
  i = -2;   /* Skip the first lines of the file which are column headings */
  for (;;i++) {
      fgets(buf,81,file); if (i < 0) continue;
      tm[i].cs = atof(buf+4);
      tm[i].cm = atof(buf+12);
      tm[i].zoe = atof(buf+22);
      tm[i].zoo = atof(buf+33);
      tm[i].zo = atof(buf+41);
      tm[i].G = atof(buf+51);
      tm[i].K = atof(buf+60);
      tm[i].Kbw = atof(buf+68);
      if (tm[i].cm == 0.0) break;
  }
  fclose(file);
  n = i;

  for (i=0; i<=n; i++) 
      printf("%2d %7.3f %7.3f   %7.3f %7.3f %7.3f   %7.3f %7.3f %7.3f\n",
          i, tm[i].cs, tm[i].cm, 
          tm[i].zoe, tm[i].zoo, tm[i].zo,
          tm[i].G, tm[i].K, tm[i].Kbw);
}

